Imports System

Module Program
  Class Romans
    Private _number As Integer

    'Define public property Number
    Public Property Number
      'Define the getter
      Get
        Return Me._number
      End Get

      'Define the setter
      Set
        If Value >= 1 And Value <= 5 Then
          Me._number = Value
        Else
          Throw New Exception("Number not recognized")
        End If
      End Set
    End Property

    'Define public property Roman
    Public Property Roman
      'Define the getter
      Get
        Dim number2roman As New Dictionary(Of Integer, String) From {
          {1, "I"}, {2, "II"}, {3, "III"}, {4, "IV"}, {5, "V"}
        }
        Return number2roman(Me._number)
      End Get

      'Define the setter
      Set
        Dim roman2number As New Dictionary(Of String, Integer) From {
          {"I", 1}, {"II", 2}, {"III", 3}, {"IV", 4}, {"V", 5}
        }

        If roman2number.ContainsKey(Value) Then
          Me._number = roman2number(Value)
        Else
          Throw New Exception("Roman numeral not recognized")
        End If
      End Set
    End Property
  End Class

  Sub Main(args As String())
    Dim x As New Romans()

    x.Number = 3
    Console.WriteLine(x.Number)  'It displays: 3
    Console.WriteLine(x.Roman)   'It displays: III

    x.Roman = "V"
    Console.WriteLine(x.Number)  'It displays: 5
    Console.WriteLine(x.Roman)   'It displays: V
  End Sub

End Module
