Imports System

Module Program
  Class FahrenheitToCelsius
    Private _temperature As Double    'This defines a private field

    'Define the constructor
    Public Sub New(value As Double)
      Me.Temperature = value  'Property is initialized. This calls the setter
    End Sub

    'Define a public property
    Public Property Temperature
      'Define the getter
      Get
        Return 5.0 / 9.0 * (Me._temperature - 32.0)
      End Get

      'Define the setter
      Set
        If Value >= -459.67 Then
          Me._temperature = Value
        Else
          Throw New Exception("There is no temperature below -459.67")
        End If
      End Set
    End Property
  End Class

  Sub Main(args As String())
    Dim x As New FahrenheitToCelsius(-50)  'Create object x. This calls the constructor which,
    'in turn, calls the setter

    Console.WriteLine(x.Temperature)   'This calls the getter.

    x.Temperature = -65                'This calls the setter
    Console.WriteLine(x.Temperature)   'This calls the getter

    x.Temperature = -500               'This calls the setter and throws an error
    Console.WriteLine(x.Temperature)
  End Sub

End Module
