Imports System

Module Program
  'Define the class SchoolMember.
  Class SchoolMember
    Public name As String
    Public age As Integer

    'Define the constructor
    Public Sub New(name As String, age As Integer)
      Me.name = name
      Me.age = age
      Console.WriteLine("A school member was initialized")
    End Sub
  End Class

  'Define the class Teacher. It inherits the class SchoolMember.
  Class Teacher
    Inherits SchoolMember

    Public salary As Double  'This is an additional field for this class

    'Define the constructor
    Public Sub New(name As String, age As Integer, salary As Double)
      MyBase.New(name, age)

      Me.salary = salary
      Console.WriteLine("A teacher was initialized")
    End Sub

    'This is an additional method for this class
    Public Sub displayValues()
      Console.WriteLine("Name: " & Me.name)
      Console.WriteLine("Age: " & Me.age)
      Console.WriteLine("Salary: " & Me.salary)
    End Sub
  End Class

  'Define the class Student. It inherits the class SchoolMember.
  Class Student
    Inherits SchoolMember

    Public finalGrade As String  'This is an additional field for this class

    'Define the constructor
    Public Sub New(name As String, age As Integer, finalGrade As String)
      MyBase.New(name, age)

      Me.finalGrade = finalGrade
      Console.WriteLine("A student was initialized")
    End Sub

    'This is an additional method for this class
    Public Sub displayValues()
      Console.WriteLine("Name: " & Me.name)
      Console.WriteLine("Age: " & Me.age)
      Console.WriteLine("Final grade: " & Me.finalGrade)
    End Sub
  End Class

  Sub Main(args As String())
    Dim teacher1 As New Teacher("Mr. John Scott", 43, 35000)
    Dim teacher2 As New Teacher("Mrs. Ann Carter", 55, 32000)

    Dim student1 As New Student("Mark Nelson", 14, "A")
    Dim student2 As New Student("Mary Morgan", 13, "B")

    teacher1.displayValues()
    teacher2.displayValues()
    student1.displayValues()
    student2.displayValues()
  End Sub

End Module
